datablock AudioProfile(BGCShotSound)
{
   filename    = "./XRPC_FIRE.wav";
   description = AudioDefault3d;
   preload = true;
};

datablock AudioProfile(BGCExplosionSound)
{
   filename    = "./XRPC_HIT.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(BGCReloadedSound)
{
   filename    = "./BGCreload.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(BGCSwitchSound)
{
   filename    = "./BGCswitch.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(BGCLoopSound)
{
   filename    = "./BGCloop.wav";
   description = AudioCloseLooping3d;
   preload = true;
};

datablock ParticleData(BGCFlashParticle)
{
	dragCoefficient      = 5;
	gravityCoefficient   = -0.0;
	inheritedVelFactor   = 0.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 1500;
	lifetimeVarianceMS   = 100;
	textureName          = "base/data/particles/chunk";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0 1 1 1";
	colors[1]     = "0 0.5 1 1";
	colors[2]     = "0 0 1 1";
	sizes[0]      = 2;
	sizes[1]      = 1;
	sizes[2]      = 0.5;
	times[0] = 0.0;
	times[1] = 0.2;
	times[2] = 1.0;
	windCoefficient = 0.0;
	useInvAlpha = false;
};

datablock ParticleEmitterData(BGCFlashEmitter)
{
	ejectionPeriodMS = 4;
	periodVarianceMS = 1;
	ejectionVelocity = 20.0;
	velocityVariance = 0.0;
	ejectionOffset   = 0.0;
	thetaMin         = 89;
	thetaMax         = 90;
	phiReferenceVel  = 360000;
	phiVariance      = 0;
	overrideAdvance = false;
	particles = "BGCFlashParticle";
	uiName = "";
};


datablock ParticleEmitterData(BGCFlashEmitter2)
{
	ejectionPeriodMS = 1;
	periodVarianceMS = 0;
	ejectionVelocity = 100.0;
	velocityVariance = 0.0;
	ejectionOffset   = 0.0;
	thetaMin         = 89;
	thetaMax         = 90;
	phiReferenceVel  = 360000;
	phiVariance      = 0;
	overrideAdvance = false;
	particles = "BGCFlashParticle";
	uiName = "";
};

AddDamageType("BGCShellDirect",   '<bitmap:add-ons/Weapon_BGC/ci_BGC> %1',    '%2 <bitmap:add-ons/Weapon_BGC/ci_BGC> %1',1,1);
AddDamageType("BGCShellRadius",   '<bitmap:add-ons/Weapon_BGC/ci_BGCRadius> %1',    '%2 <bitmap:add-ons/Weapon_BGC/ci_BGCRadius> %1',1,0);

datablock ParticleData(BGCParticle)
{
	dragCoefficient      = 10;
	gravityCoefficient   = -0.0;
	inheritedVelFactor   = 0.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 500;
	lifetimeVarianceMS   = 0;
	textureName          = "base/data/particles/dot";
	spinSpeed		= 50.0;
	spinRandomMin		= -600.0;
	spinRandomMax		= 600.0;
	colors[0]     = "0 1 1 1";
	colors[1]     = "0 1 1 1";
	colors[2]     = "0 0 1 1";
	sizes[0]      = 2;
	sizes[1]      = 1;
	sizes[2]      = 0.5;
	times[0] = 0.0;
	times[1] = 0.25;
	times[2] = 1.0;
	windCoefficient = 0.0;
	useInvAlpha = false;
};

datablock ParticleEmitterData(BGCEmitter)
{
	ejectionPeriodMS = 2;
	periodVarianceMS = 0;
	ejectionVelocity = 20;
	velocityVariance = 0.0;
	ejectionOffset   = 0.0;
	thetaMin         = 89.999999;
	thetaMax         = 90;
	phiReferenceVel  = 7600000;
	phiVariance      = 1;
	overrideAdvance = false;
	particles = "BGCParticle";
	useEmitterColors = false;
	uiName = "";
};

datablock ParticleEmitterData(BGCExplosionEmitter)
{
	ejectionPeriodMS = 1;
	periodVarianceMS = 0;
	ejectionVelocity = 6.5;
	velocityVariance = 0.5;
	ejectionOffset   = 0.0;
	thetaMin         = 89.999999;
	thetaMax         = 90;
	phiReferenceVel  = 7600000;
	phiVariance      = 1;
	overrideAdvance = false;
	particles = "BGCParticle";
	useEmitterColors = false;
	uiName = "";
};

datablock ExplosionData(BGCShellExplosion)
{
	lifeTimeMS = 250;
	particleEmitter = BGCExplosionEmitter;
	particleDensity = 10;
	particleRadius = 0.2;
	emitter[0] = BGCEmitter;
	soundProfile = BGCExplosionSound;
	faceViewer     = true;
	explosionScale = "1 1 1";
	lightStartRadius = 0;
	lightEndRadius = 0;
	lightStartColor = "0 0 0 0";
	lightEndColor = "0 0 0 0";
	damageRadius = 9;
	radiusDamage = 95;
   impulseRadius = 0;
   impulseForce = 0;
};

datablock ProjectileData(BGCShellProjectile)
{
	projectileShapeName = "base/data/shapes/empty.dts";
	directDamage        = 0;
	directDamageType = $DamageType::BGCShellDirect;
	radiusDamageType = $DamageType::BGCShellRadius;
	impactImpulse	   = 10;
	verticalImpulse	   = 10;
	explosion           = BGCShellExplosion;
	particleEmitter	   = BGCEmitter;
	sound = BGCLoopSound;
	muzzleVelocity      = 50;
	velInheritFactor    = 1.0;
	armingDelay         = 0;
	lifetime            = 30000;
	fadeDelay           = 0;
	bounceElasticity    = 0.5;
	bounceFriction      = 0.20;
	isBallistic         = true;
	gravityMod = 1;
	explodeOnDeath = true;
	hasLight    = true;
	lightRadius = 5.0;
	lightColor  = "1 0.8 0.2";
	uiName = "";
};

datablock ParticleData(BGCParticle2)
{
	dragCoefficient      = 1;
	gravityCoefficient   = -0.0;
	inheritedVelFactor   = 0.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 500;
	lifetimeVarianceMS   = 0;
	textureName          = "base/data/particles/dot";
	spinSpeed		= 50.0;
	spinRandomMin		= -600.0;
	spinRandomMax		= 600.0;
	colors[0]     = "0.5 1 1 1";
	colors[1]     = "0 1 1 1";
	colors[2]     = "0 0 1 1";
	sizes[0]      = 3;
	sizes[1]      = 2;
	sizes[2]      = 1;
	times[0] = 0.0;
	times[1] = 0.25;
	times[2] = 1.0;
	windCoefficient = 0.0;
	useInvAlpha = false;
};

datablock ParticleData(BGCParticle3)
{
	dragCoefficient      = 4;
	gravityCoefficient   = -0.0;
	inheritedVelFactor   = 0.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 3000;
	lifetimeVarianceMS   = 0;
	textureName          = "base/data/particles/dot";
	spinSpeed		= 50.0;
	spinRandomMin		= -600.0;
	spinRandomMax		= 600.0;
	colors[0]     = "0.5 1 1 1";
	colors[1]     = "0 1 1 1";
	colors[2]     = "0 0 1 1";
	sizes[0]      = 4;
	sizes[1]      = 3;
	sizes[2]      = 2;
	times[0] = 0.0;
	times[1] = 0.25;
	times[2] = 1.0;
	windCoefficient = 0.0;
	useInvAlpha = false;
};

datablock ParticleEmitterData(BGCEmitter2)
{
	ejectionPeriodMS = 1;
	periodVarianceMS = 0;
	ejectionVelocity = 0;
	velocityVariance = 0.0;
	ejectionOffset   = 0.0;
   thetaMin         = 0.0;
   thetaMax         = 90.0;  
	overrideAdvance = false;
	particles = "BGCParticle2";
	useEmitterColors = false;
	uiName = "";
};

datablock ParticleEmitterData(BGCExplosionEmitter2)
{
	ejectionPeriodMS = 1;
	periodVarianceMS = 0;
	ejectionVelocity = 50;
	velocityVariance = 0.5;
	ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
	overrideAdvance = false;
	particles = "BGCParticle3";
	useEmitterColors = false;
	uiName = "";
};

datablock ExplosionData(BGCShellExplosion2)
{
	explosionShape = "Add-Ons/Weapon_Rocket_Launcher/explosionSphere1.dts";
	soundProfile = BGCExplosionSound;
	lifeTimeMS = 1000;
	particleEmitter = BGCExplosionEmitter2;
	particleDensity = 100;
	particleRadius = 0.2;
	emitter[0] = BGCExplosionEmitter2;
	emitter[1] = BGCFlashEmitter2;
	faceViewer     = true;
	shakeCamera = true;
	camShakeFreq = "130.0 132.0 130.0";
	camShakeAmp = "52.0 52.0 52.0";
	camShakeDuration = 2.0;
	camShakeRadius = 26.0;
	explosionScale = "1 1 1";
	lightStartRadius = 10;
	lightEndRadius = 15;
	lightStartColor = "0 1 1 1";
	lightEndColor = "0 0.0 0.0 1";
	damageRadius = 19.5;
   radiusDamage = 50;
	impulseRadius = 22;
   impulseForce = 8000;
};

datablock ProjectileData(BGCShellProjectile2)
{
	projectileShapeName = "base/data/shapes/empty.dts";
	directDamage        = 500;
	directDamageType = $DamageType::BGCShellDirect;
	radiusDamageType = $DamageType::BGCShellRadius;
   brickExplosionRadius = 13;
   brickExplosionImpact = true;     
   brickExplosionForce  = 100;             
   brickExplosionMaxVolume = 300;         
   brickExplosionMaxVolumeFloating = 600; 
	impactImpulse	   = 1000;
	verticalImpulse	   = 1000;
	explosion           = BGCShellExplosion2;
	particleEmitter	   = BGCEmitter2;
	muzzleVelocity      = 50;
	velInheritFactor    = 1.0;
	armingDelay         = 0;
	lifetime            = 30000;
	fadeDelay           = 0;
	bounceElasticity    = 0.5;
	bounceFriction      = 0.20;
	isBallistic         = true;
	gravityMod = 1;
	explodeOnDeath = true;
	hasLight    = true;
	lightRadius = 10.0;
	lightColor  = "0 1 1 1";
	uiName = "BGC Shell";
};

datablock ExplosionData(BGCRecoilExplosion)
{
	explosionShape = "";
	lifeTimeMS = 150;
	faceViewer = true;
	explosionScale = "1 1 1";
	shakeCamera = true;
	camShakeFreq = "3 3 3";
	camShakeAmp = "0.3 0.5 0.4";
	camShakeDuration = 0.45;
	camShakeRadius = 10.0;
	lightStartRadius = 2;
	lightEndRadius = 4;
	lightStartColor = "0 1 1 1";
	lightEndColor = "0 0.0 0.0 1";
};

datablock ProjectileData(BGCRecoilProjectile)
{
    lifetime = 10;
    fadeDelay = 10;
    explodeondeath = true;
    explosion = BGCRecoilExplosion;
};

datablock ItemData(BGCItem)
{
	category = "Weapon";
	className = "Weapon";

	shapeFile = "./BGC.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	uiName = "Ballistic Gauss Cannon";
	iconName = "./icon_BGC";
	doColorShift = false;
	colorShiftColor = "0.471 0.471 0.471 1.000";

	image = BGCImage;
	canDrop = true;
};

datablock ShapeBaseImageData(BGCImage)
{

	shapeFile = "./BGC.dts";
   emap = true;

   mountPoint = 0;
	offset = "0.44 0.03 0.11";
	rotation = eulerToMatrix("0 0 0");

   correctMuzzleVector = true;

   className = "WeaponImage";

   item = BGCItem;
   ammo = "";
   projectile = BGCShellProjectile2;
   projectileType = Projectile;

   melee = false;
   armReady = true;

   doColorShift = true;
	colorShiftColor = "0.471 0.471 0.471 1.000";
   
	stateName[0] = "Activate";
	stateTimeoutValue[0] = 0.001;
	stateTransitionOnTimeout[0] = "Activate2";
	stateSound[0] = weaponSwitchSound;
	
	stateName[1] = "Activate2";
	stateTimeoutValue[1] = 3;
	stateTransitionOnTimeout[1] = "Ready";
	stateSound[1] = BGCSwitchSound;

	stateName[2] = "Ready";
	stateTransitionOnTriggerDown[2] = "Fire";
	stateAllowImageChange[2] = true;
	stateSequence[2] = "Idle";
	stateSound[2] = BGCReloadedSound;

	stateName[3] = "Fire";
	stateTransitionOnTimeout[3] = "Smoke";
	stateTimeoutValue[3] = 0.01;
	stateFire[3] = true;
	stateAllowImageChange[3] = false;
	stateScript[3] = "onFire";
	stateEmitter[3] = BGCFlashEmitter;
	stateEmitterTime[3] = 0.2;
	stateEmitterNode[3] = "muzzleNode";
	stateWaitForTimeout[3] = true;
	
	stateName[4] = "Smoke";
	stateEmitter[4] = BGCFlashEmitter;
	stateEmitterTime[4] = 0.2;
	stateEmitterNode[4] = tailNode;
	stateTimeoutValue[4] = 3;
	stateTransitionOnTimeout[4] = "Ready";

};

function BGCImage::OnFire(%this,%obj,%slot)
{
	%projectile = BGCShellProjectile2;
	%vector1 = VectorScale(%obj.getMuzzleVector(%slot), %projectile.muzzleVelocity);
	%vector2 = VectorScale(%obj.getVelocity(), %projectile.velInheritFactor);
	%velocity = VectorAdd(%vector1,%vector2);
	
	%p = new Projectile()
	{
		dataBlock = %projectile;
		client = %obj.client;
		initialPosition = %obj.getMuzzlePoint(%slot);
		initialVelocity = %velocity;
		sourceObject = %obj;
		sourceSlot = %slot;
	};
	
	%projectile = BGCShellProjectile;
	%vector1 = VectorScale(%obj.getMuzzleVector(%slot), %projectile.muzzleVelocity);
	%vector2 = VectorScale(%obj.getVelocity(), %projectile.velInheritFactor);
	%velocity = VectorAdd(%vector1,%vector2);
	
	%p = new Projectile()
	{
		dataBlock = %projectile;
		client = %obj.client;
		initialPosition = %obj.getMuzzlePoint(%slot);
		initialVelocity = %velocity;
		sourceObject = %obj;
		sourceSlot = %slot;
	};
	
	
	serverPlay3D(BGCShotSound,%obj.getPosition());
	
	%obj.playThread(2, plant);
	%obj.spawnExplosion(BGCRecoilProjectile,"3 3 3");
	MissionCleanup.add(%p);
	return %p;
}

function BGCImage::onMount(%this, %obj, %slot)
{
	%obj.playThread(0, plant);
}

function BGCImage::onUnMount(%this, %obj, %slot)
{
	%obj.playThread(0, root);
}